// -*- C++ -*-
// AID-GENERATED
// =========================================================================
// This class was generated by AID - Abstract Interface Definition          
// DO NOT MODIFY, but use the org.freehep.aid.Aid utility to regenerate it. 
// =========================================================================
#ifndef IO_LCEVENTLISTENER_H
#define IO_LCEVENTLISTENER_H 1

#include "EVENT/LCEvent.h"

namespace IO {

/** Listener for the occurence of LCEvents when reading a stream.
 * User classes should implement this interface for their analysis code 
 * and then register the listener with LCReader.
 * 
 * @author gaede 
 * @version Mar 11, 2003
 * @see LCEvent
 * @see LCReader
 */

class LCEventListener {

public: 
    /// Destructor.
    virtual ~LCEventListener() { /* nop */; }

    /** Call back for analyzing an LCEvent. The access to the event is 'read only'.
     *  Adding new collections to the event is allowed wheras
     * 	existing data collections and elements can not be modified.  
     */
    virtual void processEvent(EVENT::LCEvent * evt) = 0;

    /** Call back for updating an LCEvent. Here all modifications are allowed.
     *  Only use this method if you need to remove a collection from the event or 
     *  you need to modify (fix) exisiting data.
     */
    virtual void modifyEvent(EVENT::LCEvent * evt) = 0;

//     /** Call back for analyzing an LCEvent.
//      * @deprecated - use processEvent().
//      */
//     public void analyze(const LCEvent* evt) ;
//     /** Call back for updating an LCEvent.
//      * @deprecated - use modifyEvent().
//      */
//     public void update( LCEvent* evt ) ;
}; // class
} // namespace IO
#endif /* ifndef IO_LCEVENTLISTENER_H */
